package simpleex.restserver;

import org.glassfish.hk2.utilities.binding.AbstractBinder;
import org.glassfish.jersey.jackson.JacksonFeature;
import org.glassfish.jersey.server.ResourceConfig;
import simpleex.core.LatLongs;
import simpleex.restapi.LatLongObjectMapperProvider;
import simpleex.restapi.LatLongsService;

public class LatLongConfig extends ResourceConfig {

  final LatLongs latLongs;

  public LatLongConfig() {
    this(new LatLongs());
  }

  public LatLongConfig(final LatLongs latLongs) {
    this.latLongs = latLongs;
    register(LatLongsService.class);
    register(LatLongObjectMapperProvider.class);
    register(JacksonFeature.class);

    register(new AbstractBinder() {
      @Override
      protected void configure() {
        bind(latLongs);
      }
    });
  }
}
